PROFILE_DIR=$(sysconfdir)/alterator/profile.d/
MENU_DIR=$(datadir)/applications/
STANDALONE_MAP=maps/standalone-$(NAME).map

install-scripts:
	$(INSTALL) -d $(bindir)
	ln -sf /usr/bin/config-standalone $(bindir)/config-$(NAME)

build-map: 
	$(INSTALL) -d maps
	@echo '(/acc-hook view /acc-hook/$(NAME))' >$(STANDALONE_MAP)
	@echo '(/acc-hook/$(NAME) view /$(NAME) acc-description $(DESCRIPTION))' >>$(STANDALONE_MAP)


build-profile: build-map
	alterator -l -c cmdline.layout /profile/$(NAME) action write \
	acc-caption $(DESCRIPTION) \
	acc-icon alterator-$(NAME) \
	acc-modules /acc-hook/$(NAME) \
	acc-tr alterator-$(NAME) \
	acc-type system

install-profile:
	for i in profile.d/*; do install -Dpm644 $$i $(PROFILE_DIR)/`basename $$i`; done
	for i in applications/*;do install -Dpm644 $$i $(MENU_DIR)/`basename $$i`; done


clean-map:
	$(RM) $(STANDALONE_MAP)

	
clean-profile: clean-map
	$(RM) -r profile.d
	$(RM) -r applications
