;special wrappers over two frame buttons
(document:surround "/std/base")

(document:envelop with-translation _ "alterator-standalone")

;;;;;;;;;;;;;;;;;

(define (frame:replace url . args)
  (frame:clear-on-apply)
  (frame:clear-on-leave)
  (apply document:replace-in-widget (global 'frame:page) url args))

(define (frame:make-page)
  (begin-1 (document:id page-id (document:subdocument '/std/groupbox))
           (page-id layout-policy 100 100)
           (set-global! 'frame:page page-id)))

(define (frame:make-modules . args)
  (document:id modules-id (apply tree args)))

;;;;;;;;;;;;;;;;;;;;;; wizard compatibility
(define (frame:next) 'missing)
(define (frame:back) 'missing)
(define (frame:on-next thunk) 'missing)
(define (frame:on-back thunk) 'missing)

;;;;;;;;;;;;;;;;

(define (frame:on-* name thunk)
  (let ((on-* (global name)))
       (and on-* (cell-set! on-* thunk))))
(define (frame:clear-on-* name)
  (let ((on-* (global name)))
  (if on-*
      (cell-set! on-* #f)
      (set-global! name (make-cell #f)))))
(define (frame:call-on-* name)
  (and-let* ((on-* (global name))
             (on-* (cell-ref on-*)))
       (and (procedure? on-*) (on-*))))

;;;;;;;;;;;;;;;

(define (frame:on-leave thunk)
  (frame:on-* 'frame:leave thunk))
(define (frame:clear-on-leave)
  (frame:clear-on-* 'frame:leave))
(define (frame:call-on-leave)
  (frame:call-on-* 'frame:leave))

(define (frame:on-apply thunk)
  (frame:on-* 'frame:apply thunk))
(define (frame:clear-on-apply)
  (frame:clear-on-* 'frame:apply))
(define (frame:call-on-apply)
  (frame:call-on-* 'frame:apply))
